<?php

/*
Plugin Name: WP Syndicator
Plugin URI: http://www.wpsyndicator.com
Description: Automatically syndicate your content, dominate the SERPs and explode your traffic.
Version: 1.7.2
Author: Andy Fletcher
*/

require_once dirname( __FILE__ ) . '/wpal/wpalPage.php';
require_once dirname( __FILE__ ) . '/wpal/wpalBox.php';
require_once dirname( __FILE__ ) . '/wpal/wpalConfigBox.php';

require_once dirname( __FILE__ ) . '/post.php';
require_once dirname( __FILE__ ) . '/setup.php';
require_once dirname( __FILE__ ) . '/MultiCurl.php';

include 'lib/digipowertools.php';

define( 'WPSYNDICATOR_PLUGIN_BASE', substr( plugin_basename( __FILE__ ), 0,
                                            strpos( plugin_basename( __FILE__ ), '/' ) ) );
define( 'WPSYNDICATOR_PLUGIN_URL', WP_PLUGIN_URL . '/' . WPSYNDICATOR_PLUGIN_BASE );
define( 'WPSYNDICATOR_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . WPSYNDICATOR_PLUGIN_BASE );

$syn_multi_curl = null;

function syn_get_sites() {
	$sites = array();
	$config = syn_get_sites_config();
	foreach ( $config as $name => $details ) {
		$sites[] = $name;
	}
	return $sites;
}

function syn_get_sites_signup() {
	return array(
		'Wordpress' => 'http://en.wordpress.com/signup/',
		'TypePad' => 'https://www.typepad.com/secure/services/signin?register=1',
		'Blogger' => 'https://www.blogger.com/signup.g',
		'Live Journal' => 'https://www.livejournal.com/create.bml',
		'Posterous' => 'https://posterous.com/',
		'Tumblr' => 'http://www.tumblr.com/',
		'Multiply' => 'http://multiply.com/',
		'Twitter' => 'https://twitter.com/signup',
		'Plurk' => 'http://www.plurk.com/Users/showRegister',
		'Friend Feed' => 'https://friendfeed.com/account/create?formonly=1',
		'Xanga' => 'http://www.xanga.com/register.aspx',
		'Identica' => 'https://identi.ca/main/register',
		'Bit.ly' => 'http://bit.ly/a/sign_up',
    'Publr' => 'http://publr.com/signup/'
	);
}

function syn_get_sites_config() {
	return array(
		'Wordpress' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'wordpress_enabled'
			),
			'Username' => 'wordpress_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'wordpress_password',
				'password' => true
			),
			'Blog Prefix' => array(
				'type' => 'text',
				'name' => 'wordpress_prefix',
				'hint' => '<a href="http://screencast.com/t/ZGYwNjQ1ZmQt" target="_blank">What is this?</a>'
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'wordpress',
				'args' => array(
					'wordpress_username',
					'wordpress_password',
					'wordpress_prefix'
				)
			)
		),
		'TypePad' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'typepad_enabled'
			),
			'User Email' => 'typepad_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'typepad_password',
				'password' => true
			),
			'Blog ID' => array(
				'type' => 'text',
				'name' => 'typepad_blog_id',
				'hint' => '<a href="http://screencast.com/t/ZWM2ZjkyZWIt" target="_blank">What is this?</a>'
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'typepad',
				'args' => array(
					'typepad_username',
					'typepad_password',
					'typepad_blog_id'
				)
			)
		),
		'Blogger' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'blogger_enabled'
			),
			'User Email' => 'blogger_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'blogger_password',
				'password' => true
			),
			'Blog ID' => array(
				'type' => 'hidden',
				'name' => 'blogger_blog_id'
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'blogger',
				'args' => array(
					'blogger_username',
					'blogger_password'
				)
			)
		),
		'Live Journal' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'live_journal_enabled'
			),
			'Username' => 'live_journal_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'live_journal_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'livejournal',
				'args' => array(
					'live_journal_username',
					'live_journal_password'
				)
			)
		),
		'Posterous' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'posterous_enabled'
			),
			'User Email' => 'posterous_email',
			'Password' => array(
				'type' => 'text',
				'name' => 'posterous_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'posterous',
				'args' => array(
					'posterous_email',
					'posterous_password'
				)
			)
		),
		'Tumblr' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'tumblr_enabled'
			),
			'User Email' => 'tumblr_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'tumblr_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'tumblr',
				'args' => array(
					'tumblr_username',
					'tumblr_password'
				)
			)
		),
		'Multiply' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'multiply_enabled'
			),
			'Username' => 'multiply_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'multiply_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'multiply',
				'args' => array(
					'multiply_username',
					'multiply_password'
				)
			)
		),
		'Plurk' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'plurk_enabled'
			),
			'Username' => 'plurk_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'plurk_password',
				'password' => true
			),
      'API Key' => array(
        'type' => 'text',
        'name' => 'plurk_api_key',
        'hint' => '<a href="http://www.plurk.com/API/1.0/#key" target="_blank">Get an API key here</a>'
      ),
			'Test' => array(
				'type' => 'test',
				'name' => 'plurk',
				'args' => array(
					'plurk_username',
					'plurk_password',
          'plurk_api_key'
				)
			)
		),
		'Friend Feed' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'friend_feed_enabled'
			),
			'Username' => 'friend_feed_username',
			'Remote Key' => array(
				'type' => 'text',
				'name' => 'friend_feed_remote_key',
				'hint' => 'Sign up then go <a href="https://friendfeed.com/account/api" target="_blank">here</a>'
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'friendfeed',
				'args' => array(
					'friend_feed_username',
					'friend_feed_remote_key'
				)
			)
		),
		'Xanga' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'xanga_enabled'
			),
			'Username' => 'xanga_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'xanga_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'xanga',
				'args' => array(
					'xanga_username',
					'xanga_password'
				)
			)
		),
		'Identica' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'identica_enabled'
			),
			'Username' => 'identica_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'identica_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'identica',
				'args' => array(
					'identica_username',
					'identica_password'
				)
			)
		),
		'Twitter' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'twitter_enabled'
			),
			'Oauth Token' => array(
				'type' => 'hidden',
				'name' => 'twitter_oauth_token'
			),
			'Oauth Secret' => array(
				'type' => 'hidden',
				'name' => 'twitter_oauth_secret'
			)
		),
    'Publr' => array(
			'Enabled' => array(
				'type' => 'check',
				'name' => 'publr_enabled'
			),
			'User Email' => 'publr_username',
			'Password' => array(
				'type' => 'text',
				'name' => 'publr_password',
				'password' => true
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'publr',
				'args' => array(
					'publr_username',
					'publr_password'
				)
			)
    )
	);
}

function syn_default_admin_options() {
	return array(
		'excerpt_length' => 500,
		'max_daily_posts' => 2,
		'syndications_today' => 0,
		'default_anchor_text' => 'Read more ...',
		'blogger_blog_id' => 0
	);
}

function syn_get_admin_options() {
	$options = syn_default_admin_options();

	$stored_options = get_option( 'wpsyndicator' );

	if ( !empty( $stored_options ) ) {
		foreach ( $stored_options as $key => $option ) {
			$options[ $key ] = $option;
		}
	}

	return $options;
}

function syn_get_config() {
	return array(
		'Bit.ly' => array(
			'Username' => 'bitly_username',
			'API Key' => array(
				'type' => 'text',
				'name' => 'bitly_api_key',
				'hint' => 'Sign up then go <a href="http://bit.ly/a/your_api_key" target="_blank">here</a>'
			),
			'Test' => array(
				'type' => 'test',
				'name' => 'bitly',
				'args' => array(
					'bitly_username',
					'bitly_api_key'
				)
			)
		),
		'Other' => array(
			'Excerpt Length' => 'excerpt_length',
			'Auto Syndicate' => array(
				'type' => 'check',
				'name' => 'auto_syndicate'
			),
			'Auto Blog Compatibility[]' => array(
				'type' => 'check',
				'name' => 'auto_blog_compat'
			),
			'Max Daily Posts' => 'max_daily_posts',
			'Default Anchor Text' => 'default_anchor_text'
		)
	);
}

function syn_config() {
	$options = syn_get_admin_options();
	$config = syn_get_config();

	if ( isSet( $_POST[ 'syn_config' ] ) ) {
		$_POST = stripslashes_deep( $_POST );

		foreach ( $config as $site => $details ) {
			foreach ( $details as $label => $name ) {
				if ( ! is_array( $name ) ) {
					if ( isSet( $_POST[ $name ] ) ) {
						$option_name = $name;
						$value = $_POST[ $name ];
					}
				} else if ( ! isSet( $name[ 'type' ] ) || $name[ 'type' ] == 'text' ) {
					if ( isSet( $_POST[ $name[ 'name' ] ] ) ) {
						$option_name = $name[ 'name' ];
						$value = $_POST[ $option_name ];
					}
				} else {
					$option_name = $name[ 'name' ];
					$value = isSet( $_POST[ $name[ 'name'] ] );
				}
				$options[ $option_name ] = trim( $value );
			}
		}
		update_option( 'wpsyndicator', $options );
	}

	$signups = syn_get_sites_signup();

	$page = new wpalPage( 'Config' );
	$page->AddForm( '', 'post', 'syn_config' );
	foreach ( $config as $site => $fields ) {
		foreach ( $fields as $label => $details ) {
			if ( !is_array( $details ) ) {
				$fields[ $label ] = array(
					'name' => $details,
					'type' => 'text'
				);
			}
			$fields[ $label ][ 'value' ] = $options[ $fields[ $label ][ 'name' ] ];
		}
		if ( isSet( $signups[ $site ] ) ) {
			$config_box = new wpalConfigBox( $site . ' [<a href="'. $signups[ $site ] . '" target="_blank">Sign Up</a>]', $fields, true );
		} else {
			$config_box = new wpalConfigBox( $site, $fields, true );
		}
		$page->AddContentBox( $config_box );
	}
	$page->Render();
}

function syn_blog_config() {

	$options = syn_get_admin_options();
	$config = syn_get_sites_config();

	if ( isSet( $_POST[ 'syn_options' ] ) ) {
		$_POST = stripslashes_deep( $_POST );

		foreach ( $config as $site => $details ) {
			foreach ( $details as $label => $name ) {
				if ( ! is_array( $name ) ) {
					if ( isSet( $_POST[ $name ] ) ) {
						$option_name = $name;
						$value = $_POST[ $name ];
					}
				} else if ( ! isSet( $name[ 'type' ] ) || $name[ 'type' ] == 'text' ) {
					if ( isSet( $_POST[ $name[ 'name' ] ] ) ) {
						$option_name = $name[ 'name' ];
						$value = $_POST[ $option_name ];
					}
				} else {
					$option_name = $name[ 'name' ];
					$value = isSet( $_POST[ $name[ 'name'] ] );
				}
				$options[ $option_name ] = trim( $value );
			}
		}
		update_option( 'wpsyndicator', $options );
	}

	$signups = syn_get_sites_signup();

	$page = new wpalPage( 'Account Configuration' );
	$page->AddForm( '', 'post', 'syn_options' );
	foreach ( $config as $site => $fields ) {
		foreach ( $fields as $label => $details ) {
			if ( !is_array( $details ) ) {
				$fields[ $label ] = array(
					'name' => $details,
					'type' => 'text'
				);
			}
			$fields[ $label ][ 'value' ] = $options[ $fields[ $label ][ 'name' ] ];
		}
		$config_box = new wpalConfigBox( $site . ' [<a href="'. $signups[ $site ] . '" target="_blank">Sign Up</a>]', $fields, true );
		$page->AddContentBox( $config_box );
	}
	$page->Render();
}

function syn_syndicate() {
	$page = new wpalPage( 'Syndicate' );
	if ( isSet( $_POST[ 'syndicate' ] ) ) {
		$page->AddContentBox( new wpalBox( 'Syndication Complete', 'syn_syndicate_box' ) );
	} else if ( ! isSet( $_GET[ 'post_id' ] ) ) {
		$page->AddContentBox( new wpalBox( 'Select Post to Syndicate', 'syn_select_syndicate_contents' ) );
	} else {
		$page->AddContentBox( new wpalBox( 'Sites', 'syn_syndicate_sites' ) );
	}
	$page->Render();
}

function syn_success( $info, $output ) {
  if ( isset( $_GET[ 'debug' ] ) && $_GET[ 'debug' ] == 'true' ) {
    echo '<p><strong>Info</strong></p>';
    echo '<pre style="overflow: scroll;">' . htmlspecialchars( print_r( $info, true ) ) . '</pre>';
    echo '<p><strong>Output</strong></p>';
    echo '<pre style="overflow: scroll;">' . htmlspecialchars( print_r( $output, true ) ) . '</pre>';
  }
}

function syn_failure( $info, $output ) {
  if ( isset( $_GET[ 'debug' ] ) && $_GET[ 'debug' ] == 'true' ) {
    echo '<p><strong>Info</strong></p>';
    echo '<pre style="overflow: scroll;">' . htmlspecialchars( print_r( $info, true ) ) . '</pre>';
    echo '<p><strong>Output</strong></p>';
    echo '<pre style="overflow: scroll;">' . htmlspecialchars( print_r( $output, true ) ) . '</pre>';
  }
}

function hijack_curl_exec( $handle ) {
	global $syn_multi_curl;
	$syn_multi_curl->AddHandle( $handle, 'syn_success', 'syn_failure' );
	throw new MultiCurlException();
}

function syn_shorten_url( $options, $link ) {
	try {
		$login = $options[ 'bitly_username' ];
		$key = $options[ 'bitly_api_key' ];
		$longurl = urlencode( $link );

		$url = "http://api.bit.ly/v3/shorten?login=$login&apiKey=$key&longUrl=$longurl";

		$c = curl_init( $url );
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		$json = curl_exec($c);
		//$status = curl_getinfo($c, CURLINFO_HTTP_CODE);
		curl_close($c);

		$data = json_decode( $json );
		return $data->data->url;
	} catch ( Exception $e ) {
		return '';
	}
}

function syn_syndicate_post( $post_id, $sites, $anchor = '' ) {
	global $syn_multi_curl;
	$syn_multi_curl = new MultiCurl();

	$options = syn_get_admin_options();
	$anchor = trim( $anchor );
	if ( $anchor == '' ) {
		$anchor = trim( $options[ 'default_anchor_text' ] );
	}

	if ( $anchor == '' ) {
		$anchor = 'Read more ...';
	}

	$anchor = stripslashes( $anchor );

	$post = wp_get_single_post( $post_id );
	$title = $post->post_title;
	$permalink = get_permalink( $post->ID );
	$content = $post->post_content;
	$content = strip_tags( $content );

	if ( isSet( $options[ 'auto_blog_compat' ] ) && $options[ 'auto_blog_compat' ] ) {
    // strip any square brackets and their content
    $content = preg_replace( '/\[.*?(\]|$)/s', ' ', $content );
	}

	$content = substr( $content, 0, $options[ 'excerpt_length' ] );

	$last_space = strrpos( $content, ' ' );
	$content = substr( $content, 0, $last_space );

	$needle = chr( 194 ) . chr( 160 );
	$content = str_replace( $needle, ' ', $content );
	$content .= '<p><a href="' . $permalink . '">' . $anchor . '</a></p>';

	$options[ 'bitly_url' ] = syn_shorten_url( $options, $permalink );

	foreach ( $sites as $site ) {
		$site = str_replace( ' ', '_', strtolower( $site ) );
		try {
			call_user_func_array( 'syn_post_' . $site, array(
				$options, $title, $content
			));
		} catch ( MultiCurlException $mcex ) {
			// clear the aborting exception
		} catch ( Zend_Gdata_App_AuthException $zex ) {
			?><p>Blogger failed to login, please check your details and try again.</p><?php
		} catch ( Exception $ex ) {
			// an unknown error occured, do nothing about it but don't die
		}
	}
	$syn_multi_curl->Exec();

  add_post_meta( $post_id, '_syn_syndicated', true, true );

}

function syn_syndicate_box() {
	$sites = syn_get_sites();
	$enabled_sites = array();
	foreach ( $sites as $site ) {
		$site = str_replace( ' ', '_', strtolower( $site ) );
		if ( isSet( $_POST[ $site . '_enabled' ] ) ) {
			$enabled_sites[] = $site;
		}
	}

	$anchor = $_POST[ 'anchor_text' ];

	syn_syndicate_post( $_GET[ 'post_id' ], $enabled_sites, $anchor );
	?><p>Your post has been syndicated.</p><?php
}

function syn_select_syndicate_contents() { ?>
  <p>This page lists your 10 most recent posts. To syndicate an earlier post go
  to "Posts" -&gt; "Edit" and select the post you wish to syndicate. Then use
  the WPSyndicator button on the edit screen.</p>
  <ul>
    <?php foreach ( wp_get_recent_posts() as $post ) : ?>
      <li><p><a href="admin.php?page=WPSyndicator.php-syndicate&post_id=<?php echo $post[ 'ID' ]; ?>"
        ><?php echo $post[ 'post_title' ]; ?></a></p></li>
    <?php endforeach; ?>
  </ul>
<?php }

function syn_syndicate_sites() {
  $options = syn_get_admin_options();
  ?>
  <form action="" method="post">
    <input type="hidden" name="syndicate" />

    <?php
    $id = $_GET[ 'post_id' ];
    $value = trim( get_post_meta( $id, '_syn_anchor', true ) );
    if ( $value == '' ) $value = trim( $options[ 'default_anchor_text' ] );
    if ( $value == '' ) $value = 'Read more ...';
    ?>

    <p>
      <label for="anchor_text">Anchor Text</label><br />
      <input type="text" name="anchor_text" id="anchor_text" value="<?php echo $value; ?>" style="width: 98%;" />
    </p>

    <ul>
      <?php foreach ( syn_get_sites() as $site ) : ?>
        <?php $name = str_replace( ' ', '_', strtolower( $site ) ) . '_enabled'; ?>
        <li><p>
          <input type="checkbox" id="<?php echo $name; ?>" name="<?php echo $name; ?>"
                 <?php if ( $options[ $name ] ) echo 'checked="checked"'; ?> />
          <label for="<?php echo $name; ?>"><?php echo $site; ?></label>
        </p></li>
      <?php endforeach; ?>
    </ul>

    <p><input type="submit" class="button-primary" value="Syndicate" /></p>
  </form>
<?php }

function syn_edit_box() {
	if ( get_post_meta( $_GET[ 'post' ], '_syn_syndicated', true ) ) { ?>
	<p>This post has already been syndicated.</p>
<?php } ?>
	<p><a href="admin.php?page=WPSyndicator.php-syndicate&post_id=<?php echo $_GET[ 'post' ]; ?>">Click here</a> - to syndicate your post</p>
<?php }

function syn_anchor_text( $post ) {
	$value = get_post_meta( $post->ID, '_syn_anchor', true );
?>
	<input type="text" name="syn_anchor" style="width:100%" class="code" value="<?php echo $value; ?>" />
<?php }

function syn_save_postdata( $post_id ) {
	// verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
  // to do anything
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
    return $post_id;
  }

  // Check permissions
  if ( isset( $_POST[ 'post_type' ] ) && 'page' == $_POST[ 'post_type' ] ) {
    if ( !current_user_can( 'edit_page', $post_id ) )
      return $post_id;
  } else {
    if ( !current_user_can( 'edit_post', $post_id ) )
      return $post_id;
  }

  $anchor = isset( $_POST[ 'syn_anchor' ] ) ? $_POST[ 'syn_anchor' ] : null;

  update_post_meta( $post_id, '_syn_anchor', $anchor );
}

function syn_blogger() {
	$options = syn_get_admin_options();

	if ( isSet( $_POST[ 'syn_blogger' ] ) ) {
		$options[ 'blogger_blog_id' ] = $_POST[ 'blogger_blog_id' ];
		update_option( 'wpsyndicator', $options );
	}

	$page = new wpalPage( 'Blogger' );
	$page->AddContentBox( new wpalBox( 'Blogger', 'syn_blogger_content' ) );
	$page->Render();
}

function syn_blogger_content() {
	$options = syn_get_admin_options();

	if ( !isSet( $options[ 'blogger_username' ] ) || !isSet( $options[ 'blogger_password' ] ) || $options[ 'blogger_username' ] == '' || $options[ 'blogger_password' ] == '' ) {
		?><p>Please set up your Blogger username and password on the accounts screen first.</p><?php
		return;
	}

	$web2 = new Web2();
	if ( ! $web2->TestBlogger( $options[ 'blogger_username' ], $options[ 'blogger_password' ] ) ) {
		?><p>You’ve saved an invalid username/password in the account screen. Please correct it then come back.</p><?php
		return;
	}

	$selected = $options[ 'blogger_blog_id' ];
	$blogs = $web2->GetBloggerBlogs( $options[ 'blogger_username' ], $options[ 'blogger_password' ] );
?>
	<form action="" method="post">
		<input type="hidden" name="syn_blogger" value="" />
    <p><label for="blogger_blog_id">Select the blog you want to syndicate posts to:</label></p>
		<p><select name="blogger_blog_id" id="blogger_blog_id">
		<option>Choose one...</option>
		<?php foreach ( $blogs as $id => $blog ) { ?>
			<option value="<?php echo $id; ?>"<?php
				if ( $selected == $id ) { echo ' selected="selected"'; }
				echo '>';
			  echo $blog; ?></option>
		<?php } ?>
		</select></p>
		<p><input type="submit" value="Update Settings" class="button-primary" /></p>
	</form>
<?php

}

if ( !function_exists( 'syn_admin_action' ) ) {
	function syn_admin_action() {
		if ( function_exists( 'add_menu_page' ) ) {
			add_menu_page( 'WP Syndicator', 'WP Syndicator', 'manage_options', basename( __FILE__ ), 'syn_config' );
			add_submenu_page( basename( __FILE__ ), 'Config', 'Config', 'manage_options', basename( __FILE__ ), 'syn_config' );
			add_submenu_page( basename( __FILE__ ), 'Accounts', 'Accounts', 'manage_options', basename( __FILE__ ) . '-accounts', 'syn_blog_config' );
			add_submenu_page( basename( __FILE__ ), 'Blogger', 'Blogger', 'manage_options', basename( __FILE__ ) . '-blogger', 'syn_blogger' );
			add_submenu_page( basename( __FILE__ ), 'Authorize', 'Authorize', 'manage_options', basename( __FILE__ ) . '-setup', 'syn_setup' );
			add_submenu_page( basename( __FILE__ ), 'Syndicate', 'Syndicate', 'manage_options', basename( __FILE__ ) . '-syndicate', 'syn_syndicate' );
		}

		if ( function_exists( 'add_meta_box' ) ) {
			if ( isSet( $_GET[ 'action' ] ) && $_GET[ 'action' ] == 'edit' ) {
				add_meta_box( 'wpsyndicator', 'WPSyndicator', 'syn_edit_box', 'post', 'side', 'high' );
				add_meta_box( 'wpsyndicator', 'WPSyndicator', 'syn_edit_box', 'page', 'side', 'high' );
			}

			add_meta_box( 'wpsyndicator_anchor', 'Syndication Anchor Text', 'syn_anchor_text', 'post', 'normal', 'high' );
			add_meta_box( 'wpsyndicator_anchor', 'Syndication Anchor Text', 'syn_anchor_text', 'page', 'normal', 'high' );
		}
	}
}

function syn_auto_syndicate( $post_id ) {
	$options = syn_get_admin_options();

	if ( wp_is_post_revision( $post_id ) ) {
		return;
	}

	if ( isSet( $options[ 'auto_syndicate' ] ) && $options[ 'auto_syndicate' ] == true ) {

		if ( isSet( $options[ 'last_syndication' ] ) ) {
			$then_day = $options[ 'last_syndication' ];
			$now_day = date( 'Y-m-d' );

			if ( $then_day != $now_day ) {
				$options[ 'syndications_today' ] = 0;
			}
		}

		if ( get_post_meta( $post_id, '_syn_syndicated', true ) ) {
			return;
		}

		if ( $options[ 'syndications_today' ] < $options[ 'max_daily_posts' ] ) {
			$options[ 'syndications_today' ]++;
			$options[ 'last_syndication' ] = date( 'Y-m-d' );
			update_option( 'wpsyndicator', $options );

			$sites = syn_get_sites();
			$enabled_sites = array();

			foreach ( $sites as $site ) {
				$name = str_replace( ' ', '_', strtolower( $site ) ) . '_enabled';
				if ( $options[ $name ] ) {
					$enabled_sites[] = $site;
				}
			}

			$anchor_text = get_post_meta( $post_id, '_syn_anchor', true );

			syn_syndicate_post( $post_id, $enabled_sites, $anchor_text );
		}
	}
}

add_action( 'publish_post', 'syn_auto_syndicate' );
add_action( 'admin_menu', 'syn_admin_action' );
add_action( 'save_post', 'syn_save_postdata' );

add_action( 'admin_head', 'my_action_javascript' );

function my_action_javascript() {
	$img_src = WPSYNDICATOR_PLUGIN_URL . '/images/';
	$pend_src = $img_src . 'loading.gif';
	$success_src = $img_src . 'finished.png';
	$failure_src = $img_src . 'failed.png';
?>
<script type="text/javascript" >
function syn_test_site() {
	var argArray = Array.prototype.slice.call(arguments);
	var method = argArray.pop();

	var dataArray = new Array();
	for ( arg in argArray ) {
		var elem = document.getElementById( argArray[ arg ] );
		if ( elem != null ) {
			dataArray.push( elem.value );
		}
	}
	dataArray.push( method );

	var argString = dataArray.join( "|" );

	var data = {
		action : 'syn_test_site',
		args : argString
	};

	var img_id = method + '_test_image';
	var elem = document.getElementById( img_id );
	elem.src = '<?php echo $pend_src; ?>';

	jQuery.post( ajaxurl, data, function( data ) {
		var dataArray = data.split( '|' );
		var img_id = dataArray[ 0 ] + '_test_image';
		var elem = document.getElementById( img_id );
		if ( dataArray[ 1 ] == 'success' ) {
			elem.src = '<?php echo $success_src; ?>';
		} else {
			elem.src = '<?php echo $failure_src; ?>';
		}
	});
}
</script>
<?php
}

add_action('wp_ajax_syn_test_site', 'syn_test_site_callback');

function syn_test_site_callback() {
	global $wpdb; // this is how you get access to the database

	$args = explode( '|', $_POST[ 'args' ] );
	$site = array_pop( $args );

	$web2 = new Web2();
	if ( call_user_func_array( array( $web2, 'Test' . $site ), $args ) ) {
		echo "$site|success";
	} else {
		echo "$site|failure";
	}

	die();
}

?>
